SENDMAIL(8)

NAME
sendmail - send mail over the internet

SYNOPSIS
/usr/lib/sendmail [ -ba ] [ -bd ] [ -bi ] [ -bm ] [ -bp ] [ -bs ]
[ -bt ] [ -bv ] [ -bz ] [ -Cfile ] [ -dX ]
[ -Ffullname ] [ -fname ] [ -hN ] [ -n ] [ -ox value ]
[ -q[ time ] ] [ -rname ] [ -Rstring ] [ -t ] [ -v ] [ address ... ]

DESCRIPTION
sendmail sends a message to one or more people, routing the message over whatever networks are necessary. sendmail does internetwork forwarding as necessary to deliver the message to the correct place.

sendmail is not intended as a user interface routine; other programs provide user-friendly front ends; sendmail is used only to deliver pre-formatted messages.

With no flags, sendmail reads its standard input up to an EOF, or a line with a single dot and sends a copy of the letter found there to all of the addresses listed. It determines the network to use based on the syntax and contents of the addresses.

Local addresses are looked up in the local aliases(5) file, or by using the Network Information Service (NIS), and aliased appropriately. In addition, if there is a .forward file in a recipient's home directory, sendmail forwards a copy of each message to the list of recipients that file contains. Aliasing can be prevented by preceding the address with a backslash. Normally the sender is not included in alias expansions, for example, if `john' sends to `group', and `group' includes `john' in the expansion, then the letter will not be delivered to `john'.

sendmail will also route mail directly to other known hosts in a local network. The list of hosts to which mail is directly sent is maintained in the file /usr/lib/mailhosts.

OPTIONS

-ba Go into ARPANET mode. All input lines must end with a LINEFEED, and all messages will be generated with a CR-LF at the end. Also, the ``From:'' and ``Sender:'' fields are examined for the name of the sender.

-bd Run as a daemon, waiting for incoming SMTP connections.

-bi Initialize the alias database.

-bm Deliver mail in the usual way (default).

-bp Print a summary of the mail queue.

-bs Use the SMTP protocol as described in RFC 821. This flag implies all the operations of the -ba flag that are compatible with SMTP.

-bt Run in address test mode. This mode reads addresses and shows the steps in parsing; it is used for debugging configuration tables.

-bv Verify names only — do not try to collect or deliver a message. Verify mode is normally used for validating users or mailing lists.

-bz Create the configuration freeze file.

-Cfile
    Use alternate configuration file.

-dX Set debugging value to X.

-Ffullname
    Set the full name of the sender.

-fname
    Sets the name of the ``from'' person (that is, the sender of the mail). -f can only be used by ``trusted'' users (who are listed in the config file).

-hN Set the hop count to N. The hop count is incremented every time the mail is processed. When it reaches a limit, the mail is returned with an error message, the victim of an aliasing loop.

-Mid
    Attempt to deliver the queued message with message-id id.

-n  Do not do aliasing.

-oxvalue
    Set option x to the specified value. Options are described below.

-q[time]
    Processed saved messages in the queue at given intervals. If time is omitted, process the queue once. time is given as a tagged number, with s being seconds, m being minutes, h being hours, d being days, and w being weeks. For example, -q1h30m or -q90m would both set the timeout to one hour thirty minutes.

-rname
    An alternate and obsolete form of the -f flag.

-Rstring
    Go through the queue of pending mail and attempt to deliver any message with a recipient containing the specified string. This is useful for clearing out mail directed to a machine which has been down for awhile.

-t  Read message for recipients. ``To:'', ``Cc:'', and ``Bcc:'' lines will be scanned for people to send to. The ``Bcc:'' line will be deleted before transmission. Any addresses in the argument list will be suppressed.

-v  Go into verbose mode. Alias expansions will be announced, etc.

PROCESSING OPTIONS

There are also a number of processing options that may be set. Normally these will only be used by a system administrator. Options may be set either on the command line using the -o flag or in the configuration file. These are described in detail in the Installation and Operation Guide. The options are:

Afile
    Use alternate alias file.

c   On mailers that are considered ``expensive'' to connect to, do not initiate immediate connection. This requires queueing.

dx  Set the delivery mode to x. Delivery modes are i for interactive (synchronous) delivery, b for background (asynchronous) delivery, and q for queue only — that is, actual delivery is done the next time the queue is run.

D   Run newaliases(8) to automatically rebuild the alias database, if necessary.

ex  Set error processing to mode x. Valid modes are m to mail back the error message, w to ``write'' back the error message (or mail it back if the sender is not logged in), p to print the errors on the terminal (default), `q' to throw away error messages (only exit status is returned), and `e' to do special processing for the BerkNet. If the text of the message is not mailed back by modes m or w and if the sender is local to this machine, a copy of the message is appended to the file dead.letter in the sender's home directory.

Fmode
    The mode to use when creating temporary files.

f   Save UNIX-system-style ``From'' lines at the front of messages.

gN  The default group ID to use when calling mailers.

Hfile
    The SMTP help file.

i   Do not take dots on a line by themselves as a message terminator.

Ln  The log level.

m   Send to ``me'' (the sender) also if I am in an alias expansion.

o   If set, this message may have old style headers. If not set, this message is guaranteed to have new style headers (that is, commas instead of spaces between addresses). If set, an adaptive algorithm is used that will correctly determine the header format in most cases.

Qqueuedir
    Select the directory in which to queue messages.

rtimeout
    The timeout on reads; if none is set, sendmail will wait forever for a mailer.

Sfile
    Save statistics in the named file.

s   Always instantiate the queue file, even under circumstances where it is not strictly necessary.

Ttime
    Set the timeout on messages in the queue to the specified time. After sitting in the queue for this amount of time, they will be returned to the sender. The default is three days.

tstz,dtz
    Set the name of the time zone.

uN  Set the default user id for mailers.

If the first character of the user name is a vertical bar, the rest of the user name is used as the name of a program to pipe the mail to. It may be necessary to quote the name of the user to keep sendmail from suppressing the blanks from between arguments.

sendmail returns an exit status describing what it did. The codes are defined in sysexits.h
    EX_OK    Successful completion on all addresses.
    EX_NOUSER    User name not recognized.
    EX_UNAVAILABLE    Catchall meaning necessary resources
were not available.
    EX_SYNTAX    Syntax error in address.
    EX_SOFTWARE    Internal software error,
including bad arguments.
    EX_OSERR    Temporary operating system error,
such as “cannot fork”.
    EX_NOHOST    Host name not recognized.
    EX_TEMPFAIL    Message could not be sent immediately,
but was queued.

If invoked as newaliases, sendmail rebuilds the alias database. If invoked as mailq, sendmail prints the contents of the mail queue.

FILES
Except for /etc/sendmail.cf, these pathnames are all specified in /etc/sendmail.cf. Thus, these pathnames are only approximations.
/etc/aliases
    raw data for alias names
/etc/aliases.dir
/etc/aliases.pag
    data base of alias names
/etc/sendmail.cf
    configuration file
/etc/sendmail.fc
    frozen configuration
/etc/sendmail.st
    collected statistics
/usr/bin/mail
    to deliver local mail
/usr/bin/uux
    to deliver uucp mail
/usr/lib/mailhosts
    list of hosts to which mail can be sent directly
/usr/lib/sendmail.hf
    help file
/var/spool/mqueue/*
    temp files and queued mail
~/.forward
    list of recipients for forwarding messages

SEE ALSO
biff(1), bin-mail(1), mail(1), aliases(5) newaliases(8),

Su, Zaw-Sing, and Jon Postel, The Domain Naming Convention for Internet User Applications, RFC 819, Network Information Center, SRI International, Menlo Park, Calif., August 1982.

Postel, Jon, Simple Mail Transfer Protocol, RFC 821, Network Information Center, SRI International, Menlo Park, Calif., August 1982.

Crocker, Dave, Standard for the Format of ARPA-Internet Text Messages, RFC 822, Network Information Center, SRI International, Menlo Park, Calif., August 1982.

NOTES

The Network Information Service (NIS) was formerly known as Sun Yellow Pages (YP). The functionality of the two remains the same; only the name has changed.